//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//
//		File   : nsdhtmlib.js
//
//		Purpose: Generic Dhtml Library
//
// 	Version: May 22, 2001
//      
// 	Author : Steve Dugaro
//
//		Basis  : www.bratta.com
//
////////////////////// (c) Nocturn Switchcraft ///////////////////////
//////////////////////////////////////////////////////////////////////


function ns_browserInfo() {
// client browser & platform information
	this.ver   = navigator.appVersion           // browser version, platform
   this.dom   = document.getElementById?1:0    // W3C dhtml support 
   this.agent = navigator.userAgent            // browser make, platform
	this.ie6   = (this.ver.indexOf("MSIE 6") > -1 && this.dom)?1:0;
   this.ie5   = (this.ver.indexOf("MSIE 5") > -1 && this.dom)?1:0;
   this.ie4   = (document.all && !this.dom)?1:0;
   this.ns6   = (this.dom && parseInt(this.ver) >= 5 )?1:0;
   this.ns4   = (document.layers && !this.dom)?1:0;
   this.ie    = (this.ie6 || this.ie5 || this.ie4 );   
   this.ns    = (this.ns4 || this.ns6);
   this.mac   = (this.agent.indexOf("Mac") > -1 )?1:0;
   this.opera = (this.agent.indexOf("Opera 5") > -1 )?1:0;
   this.dynbr = (this.ie || this.ns || this.dom || this.opera);
   return this;
}
var br = new ns_browserInfo();

function ns_screenInfo() {
// client screen information 
	this.w  = screen.availWidth;  // exclude permanent screen objects
   this.h  = screen.availHeight;
   this.fw = screen.width;       // screen resolution
   this.fh = screen.height;  
   this.cd = screen.colorDepth;  // max # of colours user can display in bits
   return this
}

function ns_docInfo() {
// client document information. 
// - WC3 inner[Width|Height] retrievable in NS in <head>. With IE we must
//   wait until the <body> as we call document.body to get this info.

	this.x  = 0; // top, left coordinates of the page
   this.y  = 0; // w,h of document in browser
   this.bw = (br.ie && document.body.offsetWidth -5 ) || window.innerWidth  || 0;
   this.bh = (br.ie && document.body.offsetHeight-5 ) || window.innerHeight || 0;
	if (!this.bw && !this.bh ) return ns_err("Document viewing area is zero!")
   // now can specify document portions
   this.x75= (this.bw*3)/4;
   this.y75= (this.bh*3)/4;   
   this.x50= (this.bw*1)/2;
   this.y50= (this.bh*1)/2;
   this.x25= (this.bw*1)/4;
   this.y25= (this.bh*1)/4;
   this.x10= (this.bw*10)/100;
   this.y10= (this.bh*10)/100;
   return this;
}
      
function ns_obj(obj, nest) {
// call: myobject=new ns_obj('childDivName','parentDivName') 

	if(!br.dynbr) return message("This is not a 4th generation browser or better")   
   

   /* OBJECT PROPERTIES */
   
   // x-browser layer-base prefix for event trapping and prefixing
   //  IE4: document.all[divName], nestings: global
   //  NS4: document.layers[divName], nestings: refer to thier parent
   //  WC3: docuement.getElementById(divName) 
   nest=(!nest)?"":"document."+nest+".";   
   this.evnt = (br.dom)?document.getElementById(obj):
               (br.ie4)?document.all[obj]:
               (br.ns4)?eval(nest+"document.layers."+obj):0;
   if(!this.evnt) return ns_err("The layer ("+obj+") does not exist!")
   
   // x-browser css layer-base prefix
   //  IE4: document.all[divName].style.*
   //  NS4: document.layers[divName].*
   //  WC3: document.getElementById(divName).style.*
   this.css = (br.dom||br.ie4)?this.evnt.style:(br.ns4)?this.evnt:0;
   
   // x-browser image and form layer-base prefix 
   this.ref = (br.dom||br.ie4)?document:this.css.document;
   
   // x-browser local coords; use first attrib that takes
   this.x = this.css.left||this.css.pixelLeft||this.evnt.offsetLeft||0
   this.y = this.css.top||this.css.pixelTop||this.evnt.offsetTop||0
   this.w = this.ref.width||this.evnt.offsetWidth||this.css.pixelWidth||0
   this.h = this.ref.height||this.evnt.offsetHeight||this.css.pixelHeight||0
   
   // x-browser layer clipping.. initialize this objects with arg layer data
   this.c=0
   if ((br.dom || br.ie4) && this.css.clip) {
		this.c=this.css.clip; 
      this.c=this.c.slice(5,this.c.length-1); 
      this.c=this.c.split(' '); 
      for(var i=0;i<4;i++){ this.c[i] = parseInt(this.c[i])}
   }
   this.ct = this.css.clip.top||this.c[0]||0; 
   this.cr = this.css.clip.right||this.c[1]||this.w||0;
   this.cb = this.css.clip.bottom||this.c[2]||this.h||0; 
   this.cl = this.css.clip.left||this.c[3]||0;

   // define a var based on this object's name to hold 
   // a reference to itself for use with timeouts
   this.obj = obj + "Object";
   eval(this.obj + "=this")


   /* OBJECT METHOD CALL BACK REGISTRATION */
   
   this.moveTo  = ns_moveTo;
   this.moveBy  = ns_moveBy; 
   this.clipTo  = ns_clipTo;
   this.clipBy  = ns_clipBy;   
   this.print   = ns_print;
   this.setBg   = ns_setBg;
   this.show    = ns_show;
   this.hide    = ns_hide;
   this.slideLt = ns_slideLt;
   this.slideRt = ns_slideRt;
   this.slideUp = ns_slideUp;
   this.slideDn = ns_slideDn;
   
   this.animCircle = ns_animCircle;
	
   return this;
}

function ns_dropDown(obj,nest) {
// scroll down layer
	// Aggregates
	var dd = ns_obj(obj, nest)
   
   // Object Properties
   this.evnt = dd.evnt;
   this.css = dd.css;
   this.scrollHeight = (br.ns4)?this.css.document.height:this.evnt.offsetHeight;

   // Object Methods
   this.slideUp = ns_slideUp;
   this.slideDn = ns_slideDn;   
   this.moveTo  = dd.moveTo;
   this.setBg  = dd.setBg;
   this.clipTo  = dd.clipTo; 
   
   // should be able to get into dd.obj
   this.obj = obj + "Object";
   eval(this.obj + "=this");
   
   return this;
}

function ns_moveTo(x,y){
// absolutely postion this layer  
	this.x = x?x:this.x?this.x:0;
   this.y = y?y:this.y?this.y:0;
   this.css.left = x?x:this.x?this.x:0;
   this.css.top = y?y:this.y?this.y:0;
}

function ns_moveBy(x,y){
// offset this layer from its current postion
   this.moveTo(this.x+x, this.y+y);
}

function ns_clipTo(t,r,b,l,setDim){
// clip this layer to a prescribed amount
   this.ct=t; this.cr=r; this.cb = b; this.cl = l;

   if (br.ns4) {
   // actually change the 'layer' attribs
      this.css.clip.top    = t;
      this.css.clip.right  = r;
      this.css.clip.bottom = b;
      this.css.clip.left   = l;                           
   } else {
   // set the elements W3C and IE
	   if (t<0)t=0;if (r<0) r=0;if (b<0) b=0;if (l<0) l=0;                  
      this.css.clip="rect("+t+","+r+","+b+","+l+")";
      if (setDim) { 
         this.css.width=r; 
         this.css.height=b;
      }
   }
}

function ns_clipBy(t,r,b,l,setDim){
   this.clipTo(this.ct+t,this.cr+r,this.cb+b,this.cl.l,setDim)

}

function ns_print(txt, header, footer){
   if (br.ns4) {
      if (!header) {header=""; footer="";}
      // open a NS4 layer to write mime html to
      this.ref.open("text/html");
      this.ref.write(header + txt + footer);
      this.ref.close()
   } else {
     // innerHTML is not W3C but supported by ie, MozillaM16+/Gecko (NS6)
      this.evnt.innerHTML = txt;
   }
}

function ns_setBg(colour){
   if (br.dom||br.ie4) this.css.backgroundColor = colour;
   else if (br.ns4) this.css.bgColor = colour;      
}   

function ns_show(){
// show this layer
   this.css.visibility = "visible";
}

function ns_hide(){
// hide this
   this.css.visiblity = "hidden";
}
   
function ns_slideUp(yStop, incr, speed, fn, wh){
	if (!this.slideActive) {
   	if ( this.y>yStop ) {
      	this.moveTo(this.x, this.y-incr);
         eval(wh);
         setTimeout(this.obj+".slideUp("+yStop+","+incr+","+speed+",'"+fn+"','"+wh+"')",speed)
      } else {
      	this.slideActive=false;
         this.moveTo(0,yStop);
         eval(fn);
      }        
   }
}

function ns_slideDn(yStop, incr, speed, fn, wh){
	if (!this.slideActive) {
   	if ( this.y<yStop ) {
      	this.moveTo(this.x, this.y+incr);
         eval(wh);
         setTimeout(this.obj+".slideDn("+yStop+","+incr+","+speed+",'"+fn+"','"+wh+"')",speed)
      } else {
      	this.slideActive=false;
         this.moveTo(0,yStop);
         eval(fn);
      }
	}        
}

function ns_slideLt(xStop, incr, speed, fn, wh){
	if (!this.slideActive) {
   	if ( this.x>xStop ) {
      	this.moveTo(this.x-incr, this.y);
         eval(wh);
         setTimeout(this.obj+".slideLt("+xStop+","+incr+","+speed+",'"+fn+"','"+wh+"')",speed)
      } else {
      	this.slideActive=false;
         this.moveTo(xStop,0);
         eval(fn);
      }
	}        
}

function ns_slideRt(xStop, incr, speed, fn, wh){
	if (!this.slideActive) {
   	if ( this.x<xStop ) {
      	this.moveTo(this.x+incr, this.y);
         eval(wh);
         setTimeout(this.obj+".slideRt("+xStop+","+incr+","+speed+",'"+fn+"','"+wh+"')",speed)
      } else {
      	this.slideActive=false;
         this.moveTo(xStop,0);
         eval(fn);
      }
	}        
}


function ns_animCircle(direction, xo, yo, incr, speed) {
   if (!this.initialized) { // initialize
      var dx = this.x-xo;
      var dy = this.y-yo;
      this.r = Math.sqrt(dx*dx+dy*dy);      
      this.dir = (direction>=0)?1:(direction<0)?-1:1;
      this.theta = Math.atan(dy/dx);
      this.initialized = true;
   } else {      
      this.theta = this.theta+this.dir*incr*Math.PI/180;               	
      var x = xo + this.r*Math.cos(this.theta)
      var y = yo + this.r*Math.sin(this.theta)
      this.moveTo(x,y)   	      
   }
   //alert("r="+this.r+"theta="+this.theta*180/Math.PI+"this=["+this.x+","+this.y+"] delta=["+dx+","+dy+"]")   
   setTimeout(this.obj+".animCircle("+this.dir+","+xo+","+yo+","+incr+","+speed+")",speed)
}




function ns_animCircle2(xo, yo, incr, speed) {
	this.theta = (!this.theta)?incr*Math.PI/180:this.theta+incr*Math.PI/180;      
   var r = Math.sqrt((this.x-xo)*(this.x-xo)+(this.y-yo)*(this.y-yo));      
   var x = xo + r*Math.cos(this.theta)
   var y = yo + r*Math.sin(this.theta)
   alert("r="+r+"theta="+this.theta*180/Math.PI+"this=["+this.x+","+this.y+"] new["+x+","+y+"]")
   this.moveTo(x,y)
   setTimeout(this.obj+".animCircle("+xo+","+yo+","+incr+","+speed+")",speed)
}




function ns_err(txt) {
// alert and return false
	alert(txt);
   return false;
}


////////////////////////////////////////////////////////////////////////////
//  PROTECTED VARIABLES - defaults; ovverride in the client page 
////////////////////////////////////////////////////////////////////////////

var nPlace  = 0	// horizontal[0] or vertical[1] placement
var nNumDDs = 0   // number of drop downs objects to create 
var nWidDDs = 101 // width of drop downs ( also set in stylesheet )
var nSepDDs = 20  // pixels seperating drop downs
var nLeftPos= 10  // left coord of the 1st DD layer in DD array
var nTopPos = 85  // top coord of the 1st DD layer in DD array 
var nImgHgt = 11  //The position the mouseover line div will stop at when going up!
var cHiLion ='#CECFCE'// highlight color (set initial layer colour in css)
var cHiLioff='#6380BC'// highlight mouseover Color

////////////////////////////////////////////////////////////////////////////
// PUBLIC FUNCTIONS - importing page must define the prescribed vars to use
////////////////////////////////////////////////////////////////////////////

/* DROP DOWNS*/

function ddInit(panelDivName, textareaDivName, highlightDivName, numDivs){
// Initialize all the drop downs

	zindex = 10
	oDropDown=new Array()   
	nNumDDs =(!numDivs)?0:numDivs;
	for(i=0;i<=nNumDDs;i++){
		oDropDown[i]=new Array()
		oDropDown[i][0]=new ns_dropDown(panelDivName+i)
		oDropDown[i][1]=new ns_dropDown(highlightDivName+i,panelDivName+i)
		oDropDown[i][2]=new ns_dropDown(textareaDivName+i,panelDivName+i)
		oDropDown[i][1].moveTo(0,nImgHgt)
		oDropDown[i][0].clipTo(0,nWidDDs,nImgHgt+3,0)
		if(!nPlace) oDropDown[i][0].moveTo(i*nWidDDs+nLeftPos+(i*nSepDDs),nTopPos)
		else{
			oDropDown[i][0].moveTo(nLeftPos,i*nImgHgt+nTopPos+(i*nSepDDs))
			oDropDown[i][0].css.zIndex=zindex--
		}
		oDropDown[i][0].css.visibility="visible"
	}
}

function ddSetup(placement, ddwidth, seperation, leftArrayCoord, topArrayCoord, imageHeight, hColour1, hColour2){
   nPlace  = (placement==1)?1:0;
   nWidDDs = (!ddwidth)?nWidDDs:ddwidth;
   nSepDDs = (!seperation)?nSepDDs:seperation;
   nLeftPos= (!leftArrayCoord)?nLeftPos:leftArrayCoord;
   nTopPos = (!topArrayCoord)?nTopPos:topArrayCoord;
   nImgHgt = (!imageHeight)?nImgHgt:imageHeight;
   cHiLion = (!hColour1)?cHiLion:hColour1;
   cHiLioff= (!hColour2)?cHiLioff:hColour2;
}

//Moves the menu
function topMenu(num){
	if( oDropDown[num][1].y==nImgHgt ) 
   	oDropDown[num][1].slideDn(oDropDown[num][2].scrollHeight+20,10,40,'oDropDown['+num+'][0].clipTo(0,nWidDDs,oDropDown['+num+'][1].y+3,0)','oDropDown['+num+'][0].clipTo(0,nWidDDs,oDropDown['+num+'][1].y+3,0)')
	else if(oDropDown[num][1].y==oDropDown[num][2].scrollHeight+20) 
   	oDropDown[num][1].slideUp(nImgHgt,10,40,'oDropDown['+num+'][0].clipTo(0,nWidDDs,oDropDown['+num+'][1].y+3,0)','oDropDown['+num+'][0].clipTo(0,nWidDDs,oDropDown['+num+'][1].y+3,0)')
}
//Changes background onmouseover
function menuOver(num){oDropDown[num][1].setBg(cHiLioff)}
function menuOut(num){oDropDown[num][1].setBg(cHiLion)}


